package com.project.zcustom.service.unit;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.project.common.core.domain.search.PageParamVo;
import com.project.zcustom.domain.addional.LargePlan;

import java.util.Date;
import java.util.List;

/**
 * 工程计划Service接口
 *
 * @author change
 * @date 2024-12-30
 */
public interface ILargePlanService extends IService<LargePlan> {

    /**
     * 分页查询工程计划列表
     *
     * @param largePlan 工程计划
     * @return 工程计划集合
     */
    public IPage<LargePlan> pagingLargePlanList(LargePlan largePlan);

    /**
     * 分页查询工程计划列表
     *
     * @param lqw
     * @return 工程计划集合
     */
    public IPage<LargePlan> pagingLargePlanList(PageParamVo pageParamVo, LambdaQueryWrapper<LargePlan> lqw);

    /**
     * 查询工程计划列表
     *
     * @param largePlan 工程计划
     * @return 工程计划集合
     */
    public List<LargePlan> selectLargePlanList(LargePlan largePlan);

    /**
     * 查询工程计划列表
     *
     * @param largePlan 工程计划
     * @return 工程计划集合
     */
    public List<LargePlan> selectLargePlanList(LargePlan largePlan,Long limitNum);

    /**
     * 根据指定字段查询信息
     *
     * @param field 字段名称
     * @param filedValue 字段值
     * @return 工程计划
     */
    public LargePlan getLargePlanByField(String field, String filedValue);

    /**
     * 根据指定字段查询信息列表
     *
     * @param field 字段名称
     * @param filedValue 字段值
     * @return 工程计划
     */
    public List<LargePlan> selectLargePlanListByField(String field, String filedValue);

    /**
     * 根据指定字段查询信息列表
     *
     * @param field 字段名称
     * @param filedValue 字段值
     * @return 工程计划
     */
    public List<LargePlan> selectLargePlanListByField(String field, String filedValue,Long limitNum);

    /**
     *判断指定字段值是否存在
     *
     * @param field 字段名称
     * @param filedValue 字段值
     */
    public void checkFieldExist(String field, String filedValue,String tips,Long id);

    /**
     *  真删接口
     */
    public void reallyDeleteLargePlan(LambdaQueryWrapper<LargePlan> lqw);

    public int getCheckProjectNum(Date startDate, Date endDate);

    public List<LargePlan> planCheckList();

    public List<LargePlan> planDoneList();
}
